package com.lukouguoji.gjc.activity

import android.content.Context
import android.content.Intent
import android.os.Bundle
import com.alibaba.android.arouter.facade.annotation.Route
import com.lukouguoji.gjc.R
import com.lukouguoji.gjc.databinding.ActivityGjcWeighingRecordListBinding
import com.lukouguoji.gjc.viewModel.GjcWeighingRecordViewModel
import com.lukouguoji.module_base.base.BaseBindingActivity
import com.lukouguoji.module_base.common.ConstantEvent
import com.lukouguoji.module_base.impl.FlowBus
import com.lukouguoji.module_base.impl.observe
import com.lukouguoji.module_base.ktx.getLifecycleOwner
import com.lukouguoji.module_base.router.ARouterConstants

/**
 * 国际出港计重记录列表页
 */
@Route(path = ARouterConstants.ACTIVITY_URL_GJC_WEIGHING_RECORD_LIST)
class GjcWeighingRecordListActivity :
    BaseBindingActivity<ActivityGjcWeighingRecordListBinding, GjcWeighingRecordViewModel>() {

    override fun layoutId() = R.layout.activity_gjc_weighing_record_list

    override fun viewModelClass() = GjcWeighingRecordViewModel::class.java

    override fun initOnCreate(savedInstanceState: Bundle?) {
        setBackArrow("计重记录")

        binding.viewModel = viewModel

        // 初始化代理人列表
        viewModel.initAgentList()

        // 初始化特码列表
        viewModel.initSpecialCodeList()

        // 绑定分页逻辑
        viewModel.pageModel
            .bindSmartRefreshLayout(binding.srl, binding.rv, viewModel, getLifecycleOwner())

        // 监听刷新事件
        FlowBus.with<String>(ConstantEvent.EVENT_REFRESH)
            .observe(this) {
                viewModel.refresh()
            }

        // 初始加载
        viewModel.refresh()
    }

    companion object {
        @JvmStatic
        fun start(context: Context) {
            val starter = Intent(context, GjcWeighingRecordListActivity::class.java)
            context.startActivity(starter)
        }
    }
}
